//: A UIKit based Playground for presenting user interface
  
import UIKit
import PlaygroundSupport



/**
Klasse zur Beschreibung eines Bildes

- author: Klaus Reinold
- version: 0.9
*/
 class Bild
{
    /** Dateiname */
     private var name: String
    
    //Die Nachfolgerverwaltung fehlt noch.
     
    /**
    Konstruktor des Bildes
    - parameters: s Name des Bildes
    */
     init(s: String)
    {
        name = "Bilder/" + s
    }
    
    /**
     * Gibt Information über das Bild aus.
     */
    func InformationAusgeben()
    {
        print(name)
    }
    
    /**
    Gibt den Namen des Bildes aus
    - returns Name des Bildes
    */
    func NameGeben() -> String
    {
        return name
    }
}


class MyViewController : UIViewController
{
    var imageview: UIImageView!

    //Hier werden zwei einzelne Bilder verwaltet. Ersetzen durch Warteschlange!
    var bild1: Bild! = nil
    var bild2: Bild! = nil
    
    override func loadView()
    {
        
        //Hier ersetzen durch Warteschlange mit Bildern
        bild1 = Bild(s: "bild1.jpg")
        bild2 = Bild(s: "bild2.jpg")

        
        let view = UIView()
        view.backgroundColor = .white

        // Erstelle das Label mit dem ersten Bild
        // Stattdessen müsste das erste Bild aus der Warteschlange geholt werden.
        var name = bild1.NameGeben()
        let image = UIImage(named: name)
        imageview = UIImageView(image: image)
        view.addSubview(imageview)
        
        let button = UIButton(type: .roundedRect)
        button.frame = CGRect(x: 40, y: 200, width: 120, height: 30)
        button.setTitle("Bild wechseln", for: .normal)
        button.addTarget(self, action: #selector(MyViewController.KnopfGedrückt), for: .touchUpInside)
        view.addSubview(button)

        self.view = view
    }

    /**
    Aktionsfunktion für Einfügenknopf
    - parameters:
        - sender: der sendende Knopf
     */
    @objc func KnopfGedrückt(sender: UIButton)
    {
        // Ersetze das erste Bild durch das zweite Bild
        // Stattdessen müsste das nächste Bild aus der Warteschlange geholt werden.
        let nächstes: Bild = bild2
        let name = nächstes.NameGeben()
        let image = UIImage(named: name)
        imageview.image = image
    }
}
// Present the view controller in the Live View window
PlaygroundPage.current.liveView = MyViewController()
