//: A UIKit based Playground for presenting user interface
  
import UIKit
import AVKit
import PlaygroundSupport


/**
 Beschreibung der Klasse Medium

- author: Klaus Reinold
- version: 0.9
*/
 class Medium
{
    /** Dateiname */
    private var name: String
    
     //Die Referenz auf den Nachfolger und die passenden Methoden fehlen!

    /**
    Konstruktor des Mediums
    - parameters:
        - s: Name des Mediums
    */
    init(s: String)
    {
        name = "media/" + s
    }

    /**
    Gibt Information über das Medium aus.
    */
    func InformationAusgeben()
    {
        print(name)
    }
    
    /**
    Gibt den Namen des Mediums aus
    - returns Name des Mediums
    */
    func NameGeben() -> String
    {
        return name
    }
}

class MyViewController : UIViewController
{
    //medium1 und medium 2 durch Warteschlange ersetzen
    var medium1: Medium! = nil
    var medium2: Medium! = nil
    var medium: Medium! = nil
    /** Mediaplayercontroller */
    var vc: AVPlayerViewController! = nil
    
    override func loadView()
    {
        //Hier die Warteschlange befüllen
        medium1 = Medium(s: "video1.mp4")
        medium2 = Medium(s: "audio1.wav")

        //jetzt für das Anzeigen das erste Medium aus der Warteschlange holen
        medium = medium1

        let view = UIView()
        view.backgroundColor = .white

        let button = UIButton(type: .roundedRect)
        button.frame = CGRect(x: 140, y: 600, width: 120, height: 30)
        button.setTitle("Nächster", for: .normal)
        button.addTarget(self, action: #selector(MyViewController.KnopfGedrückt), for: .touchUpInside)
        view.addSubview(button)
        
        self.view = view

        var name = medium.NameGeben()
        let videoURL = Bundle.main.url(forResource: name, withExtension: "")!
        let player = AVPlayer(url: videoURL)
        vc = AVPlayerViewController()
        vc.player = player
        addChild(vc)
        view.addSubview(vc.view)
        vc.view.translatesAutoresizingMaskIntoConstraints = false
        NSLayoutConstraint.activate([
            vc.view.topAnchor.constraint(equalTo: view.topAnchor),
            vc.view.centerYAnchor.constraint(equalTo: view.centerYAnchor),
            vc.view.widthAnchor.constraint(equalTo: view.widthAnchor),
            vc.view.heightAnchor.constraint(equalTo: view.heightAnchor, constant: -200)
        ])
        vc.didMove(toParent: self)
        vc.player!.play()
    }

    
    /**
    Aktionsfunktion für Einfügenknopf
    - parameters:
        - sender: der sendende Knopf
     */
    @objc func KnopfGedrückt(sender: UIButton)
    {
        //Hier stattdesssen das nächste Medium aus der Warteschlange entfernen.
        if let nächstes = medium2
        {
            let name = nächstes.NameGeben()
            let videoURL = Bundle.main.url(forResource: name, withExtension: "")!
            let player = AVPlayer(url: videoURL)
            vc.player = player
            vc.player!.play()
        }
    }
}
// Present the view controller in the Live View window
PlaygroundPage.current.liveView = MyViewController()
